package xyz.thastertyn.UserInterface.Content;

import java.io.IOException;
import java.net.UnknownHostException;
import java.util.ArrayList;

import com.googlecode.lanterna.gui2.Label;
import com.googlecode.lanterna.gui2.Panel;
import com.googlecode.lanterna.gui2.WindowBasedTextGUI;

import xyz.thastertyn.Tuples.Pair;
import xyz.thastertyn.Types.Choice;
import xyz.thastertyn.UserInterface.UpdateListener;

public class OmluvnyList extends JecnaContent{
	
	private Panel omluvnyPanel = new Panel();
	private Label borderLabel = new Label("Omluvny L.");
	private xyz.thastertyn.Scrape.OmluvnyList omluvnyList = new xyz.thastertyn.Scrape.OmluvnyList();

	private boolean hasStarted = false;

	public OmluvnyList(UpdateListener listener)
	{
		this.listener = listener;
	}

	@Override
	public void downloadDefault()
	{
		download(null);
	}

	@Override
	protected void download(Choice choice)
	{
		try{
			omluvnyList.downloadOmluvnyList();
			setGUI();

			hasStarted = true;
		}catch(UnknownHostException e)
		{
			// omluvnyPanel.addComponent(new Label("A connection error occurred"));
		}catch(IOException e)
		{
			// omluvnyPanel.addComponent(new Label("An error occurred"));
		}
	}

	@Override
	protected void setGUI()
	{
		ArrayList<Pair<String, String>> a = omluvnyList.getData();

		for(Pair<String, String> p : a)
		{
			omluvnyPanel.addComponent(new Label(p.getValue0() + " - " + p.getValue1()));
		}
	}

	@Override
	public Panel getPanel() {
		return omluvnyPanel;
	}
	
	@Override
	public boolean hasStarted() {
		return hasStarted;
	}

	@Override
	public Label getLabel() {
		return borderLabel;
	}

	@Override
	public void showOptions(WindowBasedTextGUI textGUI) {
		// TODO Auto-generated method stub
		throw new UnsupportedOperationException("Unimplemented method 'getOptions'");
	}
}
