package xyz.thastertyn.UserInterface.Content;

import java.io.IOException;
import java.net.UnknownHostException;

import com.googlecode.lanterna.gui2.Label;
import com.googlecode.lanterna.gui2.Panel;
import com.googlecode.lanterna.gui2.WindowBasedTextGUI;
import com.googlecode.lanterna.gui2.table.Table;

import xyz.thastertyn.Types.Choice;
import xyz.thastertyn.UserInterface.UpdateListener;

public class Rozvrh extends JecnaContent {

	private Panel rozvrhPanel = new Panel();
	private Label borderLabel = new Label("Rozvrh");
	private xyz.thastertyn.Scrape.Rozvrh rozvrh = new xyz.thastertyn.Scrape.Rozvrh();

	private boolean hasStarted = false;

	private String[] labels = {"Den", "7:30-8:15", "8:25-9:10", "9:20-10:05", "10:20-11:05", "11:15-12:00", "12:10-12:55", "13:05-13:50", "14:00-14:45", "14:55-15:40", "15:50-16:35"};
	//private String[] labels = {"Den", "1.", "2.", "3.", "4.", "5.", "6.", "7.", "8.", "9.", "10."};

	String[] daysLabels = {"PO", "UT", "ST", "CT", "PA"};
	
	Table<String> t = new Table<>(labels);

	public Rozvrh(UpdateListener listener)
	{
		this.listener = listener;
	}

	@Override
	public void downloadDefault()
	{
		download(null);
	}

	@Override
	protected void download(Choice choice)
	{
		try{
			rozvrh.downloadRozvrh();
			setGUI();

			hasStarted = true;
		}catch(UnknownHostException e)
		{
			rozvrhPanel.addComponent(new Label("A connection error occurred"));
		}catch(IOException e)
		{
			rozvrhPanel.addComponent(new Label("An error occurred"));
		}
	}

	@Override
	protected void setGUI()
	{
		String[][] rozvrhArray = rozvrh.getRozvrh();
	
		String[] den = new String[11];

		for(int i = 0; i < rozvrhArray.length; i++)
		{
			den[0] = daysLabels[i];
			for(int j = 1; j < rozvrhArray[i].length + 1; j++)
			{
				den[j] = (rozvrhArray[i][j - 1].isBlank()) ? " - " : rozvrhArray[i][j - 1];
			}

			t.getTableModel().addRow(den);
		}
		rozvrhPanel.addComponent(t);
	}

	@Override
	public boolean hasStarted()
	{
		return hasStarted;
	}

	@Override
	public Panel getPanel()
	{
		return rozvrhPanel;
	}

	@Override
	public Label getLabel()
	{
		return borderLabel;
	}

	@Override
	public void showOptions(WindowBasedTextGUI textGUI) {
		// TODO Auto-generated method stub
		throw new UnsupportedOperationException("Unimplemented method 'getOptions'");
	}
}
